# -*- coding: sjis -*-

class OpenEditor(object):
	def __init__(self, editor):
		self.editor = editor
		self.called_step = CalledStepList()
	
	def SetStartColor(self, color):
		self.called_step.start_color = color
	
	def SetEndColor(self, color):
		self.called_step.end_color = color
	
	def SetClearColor(self, color):
		self.called_step.clear_color = color

class CalledStepList(object):
	# STCŎgstyle̐31ȂC܂肽g
	# ƂƗpӂĂX^CƋĂ܂
	MAX_STYLE_NUM = 31
	MAX_SAVE_TIME = 10

	def __init__(self, save_time=5, start=(0,255,0),
											end=(255,255,255), clear_color=None):
		if self.MAX_SAVE_TIME > save_time:
			self.save_time = save_time
		else:
			self.save_time = self.MAX_SAVE_TIME
		self.start_color = start
		self.end_color = end
		self.clear_color = clear_color
		
		# Ă΂ꂽs̃XgiC^[oԂƂɌĂ΂ꂽs܂Ƃ߂ēj
		# called_line = [[1,2,3], [4,5,6] ,...]
		self.called_line = [[] for i in range(save_time)]
		
		# wiFɖ߂ׂs̃Xg
		self.last_cleared = []
	
	def RegistLine(self, line_list):
		# line_list = [lineno, ...]
		self.called_line.append(line_list)
		self.NextRegist()
	
	def Regist(self, line_list):
		# line_list = [(filename, lineno, event), ...]
		line = [line_no for filename, line_no, event in line_list]
		self.called_line.append(line)
		self.NextRegist()
		
	def NextRegist(self):
		if len(self.called_line) > self.save_time:
			cleared = self.called_line.pop(0)
			if self.clear_color:
				self.last_cleared = cleared
			else:
				self.last_cleared = []
	
	def GetLines(self, index):
		"""
		index: 0`save_timeD0ƂÂo^ꂽԍ
		"""
		return self.called_line[index]
	
	def GetLastCleared(self):
		return self.last_cleared
	
	def GetStyleNum(self, index):
		return self.MAX_STYLE_NUM - index
	
	def GetColor(self, index):
		start = self.start_color
		end = self.end_color
		div = float(self.save_time - 1)
		color = []
		for i in range(3):
			diff = end[i] - start[i]
			step = diff / div
			color.append(end[i] - step * index)
		return color
	