import wx
import wx.stc  as  stc
from default import StyledTextCtrl, register
import keyword

class PythonSTC(StyledTextCtrl):
  lexer = stc.STC_LEX_PYTHON
  fold_symbols = 2
  
  def __init__(self, parent, ID,
      pos=wx.DefaultPosition, size=wx.DefaultSize,
      style=0):
    StyledTextCtrl.__init__(self, parent, ID, pos, size, style)
    self.SetKeyWords(0, " ".join(keyword.kwlist))

  def OnKeyPressed(self, event):
    if self.CallTipActive():
      self.CallTipCancel()
    key = event.KeyCode

    if key == 32 and event.ControlDown():
      pos = self.GetCurrentPos()

      # Tips
      if event.ShiftDown():
          self.CallTipSetBackground("yellow")
          self.CallTipShow(pos, 'lots of of text: blah, blah, blah\n\n'
                           'show some suff, maybe parameters..\n\n'
                           'fubar(param1, param2)')
      # Code completion
      else:
        kw = keyword.kwlist[:]
        kw.sort()
        self.AutoCompSetIgnoreCase(False)  # so this needs to match

        # Images are specified with a appended "?type"
        for i in range(len(kw)):
          if kw[i] in keyword.kwlist:
            kw[i] = kw[i] + "?1"

        self.AutoCompShow(0, " ".join(kw))
    else:
      event.Skip()

register(u'.py', u'Python Source Code (*.py)', PythonSTC)
register(u'.pyw', u'Python Source Code (*.pyw)', PythonSTC)
