# -*- coding: sjis -*-
import os, sys
import threading
from bdb import Bdb

class MyBdb(Bdb):
	def __init__(self):
		Bdb.__init__(self)
		self.step_callback = lambda filename, line_no, event: None
	
	def trace_dispatch(self, frame, event, arg):
		f_name = frame.f_code.co_filename
		filename = self.canonic(frame.f_code.co_filename)
		#print filename, frame.f_lineno, "Event:",event
		self.step_callback(filename, frame.f_lineno, event)
		if not filename.startswith("<"):
			pass
			#print dir(frame)
			#print frame.f_globals
			#print frame.f_locals
			#self.count += 1
		if self.quitting:
		    return # None
		if event == 'line':
		    return self.dispatch_line(frame)
		if event == 'call':
		    return self.dispatch_call(frame, arg)
		if event == 'return':
		    return self.dispatch_return(frame, arg)
		if event == 'exception':
		    return self.dispatch_exception(frame, arg)
		if event == 'c_call':
		    return self.trace_dispatch
		if event == 'c_exception':
		    return self.trace_dispatch
		if event == 'c_return':
		    return self.trace_dispatch
		print 'bdb.Bdb.dispatch: unknown debugging event:', repr(event)
		return
	
	def runscript(self, filename):
		globals_ = {"__name__" : "__main__", "__file__" : filename}
		locals_ = globals_
		statement = "execfile('%s')" % filename
		statement = statement.replace("\\", "/")
		print "stm:",repr(statement)
		self.run(statement, globals=globals_, locals=locals_)
		print "finish debugging"

class Debugger(threading.Thread):
	def __init__(self, script_name, lock, open_editors):
		threading.Thread.__init__(self)
		
		# called_line = {filename1: [1,3,4, ...], filename2: [3,2,5,..], ... }
		self.ClearCalledLine()
		self.open_editors = open_editors
		self.script_name = script_name
		self.lock = lock
		self.bdb = MyBdb()
		self.bdb.step_callback = self.OnStepCallback
	
	def ClearCalledLine(self):
		self.called_line = {}
	
	def OnStepCallback(self, filename, lineno, event):
		#print "stepcall", event, lineno
		self.lock.acquire()
		if filename in self.open_editors:
			lines = self.called_line.setdefault(filename, [])
			lines.append([filename, lineno-1, event])
		self.lock.release()
	
	def run(self):
		self.bdb.runscript(self.script_name)

def main():
	pass
	#bdb = MyBdb()
	#bdb.run('twtoweb.main()')

if __name__ == '__main__':
	main()
